var currentPath = process.cwd();
var AdmZip = require('adm-zip');
var path = require('path');
var bsdiff = require('node-bsdiff');
var moment = require('moment');
var _ = require('lodash');
var fs = require('fs');
function diffZip(origin, next, output) {
    var originZip = new AdmZip(origin);
    var originZipEntries = originZip.getEntries();
    var originData = {};
    var originMap = {};
    var copies = {};
    var regexp = /[0-9]+/g;
    var originBundleVersion = origin.match(regexp)[0];
    var nextBundleVersion = next.match(regexp)[0];
    output = originBundleVersion + '-' + nextBundleVersion;
    outputZip = new AdmZip();
    mkdir('-p', path.join(currentPath, output));
    mkdir('-p', path.join(currentPath, 'diff'));
    originZipEntries.forEach(function(zipEntry) {
        originData[zipEntry.entryName] = zipEntry.getData();
        originMap[zipEntry.entryName] = zipEntry.entryName;
    });
    var nextZip = new AdmZip(next);
    var nextZipEntries = nextZip.getEntries();
    nextZipEntries.forEach(function(zipEntry) {
        if (zipEntry.entryName === 'index.bundlejs') {
            var diff = bsdiff.diff(originData[zipEntry.entryName], zipEntry.getData());
            addEntry(path.join(output, 'index.bundlejs.patch'), diff);
        }
        if (!originData[zipEntry.entryName] && !zipEntry.isDirectory) {
            copies[zipEntry.entryName] = zipEntry.entryName;
            console.log(zipEntry.entryName);
            addEntryDirectory(path.join(output, zipEntry
                .entryName
                .substring(0, zipEntry.entryName.lastIndexOf('/'))));
            addEntry(path.join(output, zipEntry.entryName), zipEntry.getData());
        }
    });
    if (!_.isEmpty(copies)) {
        addEntry(path.join(output, 'diff.json'), JSON.stringify(copies));
    }
    setTimeout(function() {
        cd(path.join(currentPath, output));
        exec('zip -r ../diff/' + originBundleVersion + '-' + nextBundleVersion + '.zip *');
        cd('../');
        rm('-rf', path.join(currentPath, output));
    }, 1000);
}

function generateBundle(platform) {
    var cdate = moment().format('YYYYMMDDHHmm');
    var output = "output";
    var temp = "temp";
    rm('-rf', currentPath + '/' + output + '/' + temp);
    mkdir('-p', currentPath + '/' + output + '/' + temp);
    exec('react-native bundle ' +
        '--entry-file ' +
        'index.' + platform +'.js ' +
        '--bundle-output ' +
        './' + output + '/' + temp + '/index.bundlejs ' +
        '--platform ' + platform + ' ' +
        '--assets-dest  ' + output + '/' + temp + ' ' +
        '--dev false');
    cd(currentPath + '/' + output + '/' + temp);
    exec('zip -r ' + platform + '.bundle.' + cdate + '.zip *');
    mv('-f', platform + '.bundle.' + cdate + '.zip', '../');
    cd(currentPath);
    echo('build success');
}

function addEntry(output, data) {
    console.log(output);
    touch(output);
    fs.writeFile(output, data, function(err) {
        console.log(err);
    });
}

function addEntryDirectory(output) {
    mkdir('-p', output);
}

module.exports = {
    diffZip: diffZip,
    generateBundle: generateBundle
}